#!/use/bin/env python
# -*- coding: utf-8 -*-

import numpy as np
import sys
import os
import caffe

MODEL_FILE = './lenet_deploy.prototxt'
PRETRAINED = './lenet_iter_20000.caffemodel'

argvs = sys.argv
argc = len(argvs)

# 画像のパスをコマンドライン引数から受け取る
if argc < 2:
    print("Usage: python classify_chars.py <imagepath>")
    sys.exit(1)

IMAGE_FILE = argvs[1]

# 学習済みのCaffeのモデルの存在を確認
if not os.path.isfile(PRETRAINED):
    print("error: pre-trained Caffe model...")

# CPUモードを設定
caffe.set_mode_cpu()

# モデルの読み込み
net = caffe.Classifier(MODEL_FILE,
        PRETRAINED, channel_swap=[0], image_dims=(28, 28))

# 入力画像の読み込み
input_image = caffe.io.load_image(IMAGE_FILE, color=False)

# 画像分類処理を実行
prediction = net.predict([input_image], False)

# 予測結果を出力
print("prediction shape: {}".format(prediction[0].shape))
print("predicted class: {}".format(prediction[0].argmax()))
